 
addpath /home/studenter/havardla/uwbnettverk/banchan/bodychannel;
addpath /home/studenter/havardla/uwbnettverk/banchan;
rmpath /opt/MathWorks/MATLAB_R14-SP3/toolbox/nnet/nnet;
rmpath /opt/MathWorks/MATLAB_R14-SP3/toolbox/nnet/nnutils;
rmpath /opt/MathWorks/MATLAB_R14-SP3/toolbox/nnet/nncontrol;
rmpath /opt/MathWorks/MATLAB_R14-SP3/toolbox/nnet/nndemos;
rmpath /opt/MathWorks/MATLAB_R14-SP3/toolbox/nnet/nnobsolete;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%filtrert versjon
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fc =17e9;
dPPM = 2.5e-9;
Ns=[1 3 5 8 9 10 11 15];
Ts =[228e-9 228e-9 228e-9 228e-9];
Pow=-20;
rand('state',sum(100*clock))
fb=2;
Fskift=4e9;
antallsimuleringer=10;
fingers=[1 3 5 7];
%Definere antall tilfeldig genererte bit som hver node skal benytte.



for simnr=1:antallsimuleringer;


for antNs=1:length(Ns)


nodeinfo{1,1}='front';
nodeinfo{1,2}=0.14;
nodeinfo{2,1}='side';
nodeinfo{2,2}=0.27;
nodeinfo{3,1}='back';
nodeinfo{3,2}=0.37;
nodeinfo{4,1}='back';
nodeinfo{4,2}=0.49;


%sendebits(1,:)=[1 1 1 0 1 1 1 1 1 1 0 0 0 0 0 0 0];
%sendebits(2,:)=[1 1 1 1 1 0 0 0 0 0 0 1 1 1 1 1 1];
%sendebits(3,:)=[1 1 1 1 1 0 0 0 0 0 0 1 1 1 1 1 1]; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            Sender
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for n=1:size(nodeinfo,1)
bits(n,:)=cp0201_bits(250);
[bits(n,:),THcodes(n,:),Stxtot(n,:),Referanse(n,:)]=cp0201_transmitter_2PPM_TH_3_rake(bits(n,:),dPPM,fc,Ns(antNs),Ts(n),Pow);

end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Noen Plotter                                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%figure
%psd=cp0301_PSD(Stxtot,fc);
%title('Stx')
%figure
%psd=cp0301_PSD(Referanse,fc);
%title('Referanse')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for n=1:size(nodeinfo,1)

    
%Genererer nedkonvertert referanse signal   
[Ref_BPfilt]=bandpass(Referanse(n,:),fc);
Ref_hilb=hilbert(Ref_BPfilt);

tid = 0:(1/fc):(length(Ref_hilb)*(1/fc)); %Genererer en tidsvektor for nedkonverteringsmatrisen.
Downcon=exp(-j*2*pi*Fskift*tid(1:(length(tid)-1))); %Generer nedkonverteringsmatrisen
Ref_DC=Downcon.*Ref_hilb; %Danner nedtxkonvertert signal
Ref_DC_DS(n,:)=resample(Ref_DC,fb,(fc/(1e9)));
clear Ref_BPfilt Ref_hilb Ref_DC Downcon tid;

%Genererer nedkonvertert Sendersignal
[Stx_BPfilt]=bandpass(Stxtot(n,:),fc); %Bandpassfiltrer signalet 3-5GHz
disp('BP filtrert - DONE!')
Stx_hilb=hilbert(Stx_BPfilt);  %Hilbert transformerer signalet for  f det p kompleks form.
disp('Hilbert transformasjon - DONE!')

tid = 0:(1/fc):(length(Stx_hilb)*(1/fc)); %Genererer en tidsvektor for nedkonverteringsmatrisen.
Downcon=exp(-j*2*pi*Fskift*tid(1:(length(tid)-1))); %Generer nedkonverteringsmatrisen
Stx_DC=Downcon.*Stx_hilb; %Danner nedkonvertert signal
Stx_DC_DS(n,:)=resample(Stx_DC,fb,(fc/(1e9)));
clear Stx_BPfilt Downcon tid Stx_hilb Stx_DC;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%ploter                                    %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%figure
%psd=cp0301_PSD(Stx_BPfilt,fc);
%title('stx_filt')
%figure
%psd=cp0301_PSD(Ref_BPfilt,fc);
%title('ref_filt')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Genererer kanalmodell
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for n=1:size(nodeinfo,1);

hkanal{n} = uwbchannel('BAN_indoor',0.5,nodeinfo{n,1},1,nodeinfo{n,2});
hkanal{n}=transpose(hkanal{n});

%hkanal_US=resample(hkanal,fb,2);




Konvolusjon = conv(Stx_DC_DS(n,:),hkanal{n}); %Generere mottat signal hos mottakeren
Mottatt_Baseband(n,:) = Konvolusjon(1:length(Stx_DC_DS(n,:)));

clear Konvolusjon;

end
%Mottatt_US=resample(Mottatt_Baseband,(fc/(1e9)),fb);
%tid = 0:(1/fc):(length(Mottatt_US)*(1/fc));
%Upcon=exp(j*2*pi*Fskift*tid(1:(length(tid)-1)));
%Mottatt_US_UC=Upcon.*Mottatt_US;
%clear tid;
%clear Upcon;

%Mottatt=real(Mottatt_US_UC);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Signal shift
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if size(nodeinfo,1)>1;
for n=1:size(nodeinfo,1);
       delay=(Ts(1))*rand;
       Mottatt_Baseband_shift{n}=cp0804_signalshift(Mottatt_Baseband(n,:),(fb*10^9),delay);
end

for node=1:size(nodeinfo,1);
    node
%Genererer shiftet totalsignal fra node nr 1, til node nr:node
 Mottatt_shift_sum{1}=0;   
k=1;
    while k<node
        Mottatt_shift_sum{1}=sumarray(Mottatt_Baseband_shift{k},Mottatt_shift_sum{1});
        k
        k=k+1;
    end

%Generer shiftet sum fra node nr:#node+1 til node totalt, bortsett fra for siste
%node.
    k=node+1;
   while k<=size(nodeinfo,1);
      Mottatt_shift_sum{1}=sumarray(Mottatt_Baseband_shift{k},Mottatt_shift_sum{1}); 
    k
      k=k+1;
   end


   %summerer shiftet signal av de andre nodene med baseband signal til
   %noden som skal dekodes.
   Mottatt_Baseband_tot{node}=sumarray(Mottatt_shift_sum{1},Mottatt_Baseband(node,:));
   
end
clear Mottatt_shift_sum Mottatt_Baseband_shif;

else
    Mottatt_Baseband_tot{1}=Mottatt_Baseband(1,:);
    disp('bare 1 node')
end
%legger til stoy
for n=1:size(nodeinfo,1)
    numpulser=Ns(antNs)*length(bits(n,:))

[output(n,:),noise_real,noise_complex,SNRdB] = stoy_AWGN_ny(Stx_DC_DS(n,:),numpulser,Pow,fb,Ts(n));

outputny(n,:)=Mottatt_Baseband_tot{n}+noise_complex;
end






%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Maske generateor
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for n=1:size(nodeinfo,1);
numpulser=Ns(antNs)*length(bits(n,:));
[G,T,NF,Arake(n,:),Srake(n,:),Prake(n,:)] = cp0803_rakeselector(hkanal{n},(fb*10^9),(1/(fb*10^9)),fingers(n),fingers(n));
[mask0(n,:), mask1(n,:)] = cp0801_PPMcorrmask_moda_conj(Ref_DC_DS(n,:),(fb*10^9),numpulser,dPPM);
[mask_R0(n,:), mask_R1(n,:)] = cp0801_PPMcorrmask_rake2(Ref_DC_DS(n,:),(fb*10^9),numpulser,dPPM,Srake(n,:));

end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Mottaker
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for n=1:size(nodeinfo,1)
numbit = length(bits(n,:));
[RXbits_rake(n,:),BER_rake(n)] = cp0801_PPMreceiver_moda(outputny(n,:),mask_R0(n,:), mask_R1(n,:),(fb*10^9),bits(n,:),numbit,Ns(antNs),Ts(n));
[RXbits_rake_Ustoy(n,:),BER_rake_Ustoy(n)] = cp0801_PPMreceiver_moda(Mottatt_Baseband(n,:),mask_R0(n,:), mask_R1(n,:),(fb*10^9),bits(n,:),numbit,Ns(antNs),Ts(n));
[RXbits_DC_UStoy(n,:),BER_DC_UStoy(n)] = cp0801_PPMreceiver_moda(Stx_DC_DS(n,:),mask0(n,:),mask1(n,:),(fb*10^9),bits(n,:),numbit,Ns(antNs),Ts(n));
clear stoy tempRxtot temp2RXtot;
end



for k=1:size(nodeinfo,1)
Ns_RAKE_BER{k,antNs}=[BER_rake(k) BER_rake_Ustoy(k) BER_DC_UStoy(k)]
end
clear Stxtot Referanse pulsrekke Ref_DC_DS Mottatt_Baseband THcodes Stx_DC_DS noise_real noise_complex output noise3 output3 outputny Mottatt_Baseband_tot mask0 mask1 mask_R0 mask_R1;
end
resultat{simnr}=Ns_RAKE_BER;
end
save sim_rakeNS_opt.mat resultat Ns fingers numbit Pow;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Plotter
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%figure
%plot(Mottatt)
%title('Mottatt signal ved basebandkonvolusjon')
