addpath /home/studenter/havardla/uwbnettverk/banchan/bodychannel;
addpath /home/studenter/havardla/uwbnettverk/banchan;
rmpath /opt/MathWorks/MATLAB_R14-SP3/toolbox/nnet/nnet;
rmpath /opt/MathWorks/MATLAB_R14-SP3/toolbox/nnet/nnutils;
rmpath /opt/MathWorks/MATLAB_R14-SP3/toolbox/nnet/nncontrol;
rmpath /opt/MathWorks/MATLAB_R14-SP3/toolbox/nnet/nndemos;
rmpath /opt/MathWorks/MATLAB_R14-SP3/toolbox/nnet/nnobsolete;

fc =17e9;
dPPM = 2.5e-9;
Ns=[1];


Ts =130e-9;
Pow=-20;
rand('state',sum(100*clock))
fb=2;
Fskift=4e9;
antallrealiseringer=15000;


nodeinfo{1,1}='front';
nodeinfo{1,2}=0.14;
nodeinfo{2,1}='side';
nodeinfo{2,2}=0.27;
nodeinfo{3,1}='back';
nodeinfo{3,2}=0.37;
nodeinfo{4,1}='back';
nodeinfo{4,2}=0.49;


%sendebits(1,:)=[1 1 1 0 1 1 1 1 1 1 0 0 0 0 0 0 0];
%sendebits(2,:)=[1 1 1 1 1 0 0 0 0 0 0 1 1 1 1 1 1];
%sendebits(3,:)=[1 1 1 1 1 0 0 0 0 0 0 1 1 1 1 1 1]; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            Sender
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

bits(1)=0;

[bits,THcodes,Stxtot,Referanse]=cp0201_transmitter_2PPM_TH_3_rake2(bits,dPPM,fc,Ns,Ts,Pow);


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Noen Plotter                                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%figure
%psd=cp0301_PSD(Stxtot,fc);
%title('Stx')
%figure
%psd=cp0301_PSD(Referanse,fc);
%title('Referanse')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for n=1:1;

   

%Genererer nedkonvertert Sendersignal
[Stx_BPfilt]=bandpass(Stxtot(n,:),fc); %Bandpassfiltrer signalet 3-5GHz
disp('BP filtrert - DONE!')
Stx_hilb=hilbert(Stx_BPfilt);  %Hilbert transformerer signalet for  f det p kompleks form.
disp('Hilbert transformasjon - DONE!')

tid = 0:(1/fc):(length(Stx_hilb)*(1/fc)); %Genererer en tidsvektor for nedkonverteringsmatrisen.
Downcon=exp(-j*2*pi*Fskift*tid(1:(length(tid)-1))); %Generer nedkonverteringsmatrisen
Stx_DC=Downcon.*Stx_hilb; %Danner nedkonvertert signal
Stx_DC_DS(n,:)=resample(Stx_DC,fb,(fc/(1e9)));
clear Stx_BPfilt Downcon tid Stx_hilb Stx_DC;
end



Mottatt_Baseband=zeros(size(nodeinfo,1),length(Stx_DC_DS(1,:)));
for n=1:size(nodeinfo,1);

hkanal{n} = uwbchannel('BAN_indoor',0.5,nodeinfo{n,1},antallrealiseringer,nodeinfo{n,2});



for k=1:antallrealiseringer;
 
    
Konvolusjon = conv(Stx_DC_DS(1,:),transpose(hkanal{n}(:,k))); %Generere mottat signal hos mottakeren

Mottatt_realiseringer{n,k}=Konvolusjon(1:length(Stx_DC_DS(1,:)));

Mottatt_Baseband(n,:)=Mottatt_realiseringer{n,k}+Mottatt_Baseband(n,:);
end
Mottatt_Baseband(n,:)=Mottatt_Baseband(n,:)./antallrealiseringer;
end

tid=linspace(0,(length(Mottatt_Baseband(1,:))*(1/2e9))/1e-9,length(Mottatt_Baseband(1,:)));

plotnode(tid,abs(Mottatt_Baseband(1,:)))
plotnode(tid,abs(Mottatt_Baseband(2,:)))
plotnode(tid,abs(Mottatt_Baseband(3,:)))
plotnode(tid,abs(Mottatt_Baseband(4,:)))


save snittpuls.mat tid Mottatt_Baseband;





