 
addpath /home/studenter/havardla/uwbnettverk/banchan/bodychannel;
addpath /home/studenter/havardla/uwbnettverk/banchan;
rmpath /opt/MathWorks/MATLAB_R14-SP3/toolbox/nnet/nnet;
rmpath /opt/MathWorks/MATLAB_R14-SP3/toolbox/nnet/nnutils;
rmpath /opt/MathWorks/MATLAB_R14-SP3/toolbox/nnet/nncontrol;
rmpath /opt/MathWorks/MATLAB_R14-SP3/toolbox/nnet/nndemos;
rmpath /opt/MathWorks/MATLAB_R14-SP3/toolbox/nnet/nnobsolete;
        

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%filtrert versjon
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
fc =17e9;
dPPM = 2.5e-9;
Ns=[1 3 6 9 12 15 20 30];

Ts =[228e-9 228e-9 228e-9 228e-9];
Pow=-20;
rand('state',sum(100*clock))
fb=2;
Fskift=4e9;
antallsimuleringer=10;

%Definere antall tilfeldig genererte bit som hver node skal benytte.



for simnr=1:antallsimuleringer;


for Nsnr=1:length(Ns)




%nodeinfo{1,1}='front';
%nodeinfo{1,2}=0.14;
%nodeinfo{2,1}='side';
%nodeinfo{2,2}=0.27;
%nodeinfo{3,1}='back';
%nodeinfo{3,2}=0.37;
nodeinfo{1,1}='back';
nodeinfo{1,2}=0.49;


%sendebits(1,:)=[1 1 1 0 1 1 1 1 1 1 0 0 0 0 0 0 0];
%sendebits(2,:)=[1 1 1 1 1 0 0 0 0 0 0 1 1 1 1 1 1];
%sendebits(3,:)=[1 1 1 1 1 0 0 0 0 0 0 1 1 1 1 1 1]; 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            Sender
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for n=1:size(nodeinfo,1)
bits(n,:)=cp0201_bits(250);
[bits(n,:),THcodes(n,:),Stxtot(n,:),Referanse(n,:)]=cp0201_transmitter_2PPM_TH_3_rake(bits(n,:),dPPM,fc,Ns(Nsnr),Ts(n),Pow);

end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Noen Plotter                                                   %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%figure
%psd=cp0301_PSD(Stxtot,fc);
%title('Stx')
%figure
%psd=cp0301_PSD(Referanse,fc);
%title('Referanse')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for n=1:size(nodeinfo,1)

    
%Genererer nedkonvertert referanse signal   
[Ref_BPfilt]=bandpass(Referanse(n,:),fc);
Ref_hilb=hilbert(Ref_BPfilt);

tid = 0:(1/fc):(length(Ref_hilb)*(1/fc)); %Genererer en tidsvektor for nedkonverteringsmatrisen.
Downcon=exp(-j*2*pi*Fskift*tid(1:(length(tid)-1))); %Generer nedkonverteringsmatrisen
Ref_DC=Downcon.*Ref_hilb; %Danner nedtxkonvertert signal
Ref_DC_DS(n,:)=resample(Ref_DC,fb,(fc/(1e9)));
clear Ref_BPfilt Ref_hilb Ref_DC Downcon tid;

%Genererer nedkonvertert Sendersignal
[Stx_BPfilt]=bandpass(Stxtot(n,:),fc); %Bandpassfiltrer signalet 3-5GHz
disp('BP filtrert - DONE!')
Stx_hilb=hilbert(Stx_BPfilt);  %Hilbert transformerer signalet for  f det p kompleks form.
disp('Hilbert transformasjon - DONE!')

tid = 0:(1/fc):(length(Stx_hilb)*(1/fc)); %Genererer en tidsvektor for nedkonverteringsmatrisen.
Downcon=exp(-j*2*pi*Fskift*tid(1:(length(tid)-1))); %Generer nedkonverteringsmatrisen
Stx_DC=Downcon.*Stx_hilb; %Danner nedkonvertert signal
Stx_DC_DS(n,:)=resample(Stx_DC,fb,(fc/(1e9)));
clear Stx_BPfilt Downcon tid Stx_hilb Stx_DC;
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%ploter                                    %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%figure
%psd=cp0301_PSD(Stx_BPfilt,fc);
%title('stx_filt')
%figure
%psd=cp0301_PSD(Ref_BPfilt,fc);
%title('ref_filt')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Genererer pulsrekker for ulike realiseringer for kanalmodelln
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
dt2 = (1/ (fb*10^9));                   % sampling periode
samplesTs = floor(Ts(1)/dt2);             %sampler per pulsintervall
numpulser=Ns(Nsnr)*length(bits(n,:));
antallkanaler=30;                      %antall kanalrealiseringer som skal benyttes, tilsvarende antall etterflgende pulser med ulik kanal


for n=1:ceil(numpulser/antallkanaler);

vektor((1+antallkanaler*n*samplesTs):(1+antallkanaler*n*samplesTs)+samplesTs-1)=1;
end


vektor=vektor(samplesTs+1:length(vektor));

pulsrekke(1,:)=vektor(1:length(Stx_DC_DS));
skiftetpulsrekke(1,:)=vektor;
for n=2:(antallkanaler)
skiftetpulsrekke=vektor([end-((n-1)*samplesTs)+1:end 1:end-((n-1)*samplesTs)]);
pulsrekke(n,:)=skiftetpulsrekke(1:length(Stx_DC_DS));
end
clear vektor skiftetpulsrekke;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Genererer kanalmodell
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

Mottatt_Baseband=zeros(size(nodeinfo,1),length(Stx_DC_DS(1,:)));
for n=1:size(nodeinfo,1);

hkanal{n} = uwbchannel('BAN_indoor',0.5,nodeinfo{n,1},30,nodeinfo{n,2});


%hkanal_US=resample(hkanal,fb,2);




for k=1:size(pulsrekke,1);
 
    
Konvolusjon = conv((pulsrekke(k,:).*Stx_DC_DS(n,:)),transpose(hkanal{n}(:,k))); %Generere mottat signal hos mottakeren

Mottatt_realiseringer=Konvolusjon(1:length(Stx_DC_DS(n,:)));

Mottatt_Baseband(n,:)=Mottatt_realiseringer+Mottatt_Baseband(n,:);
end

end
clear Konvolusjon Mottatt_realiseringer;
%Mottatt_US=resample(Mottatt_Baseband,(fc/(1e9)),fb);
%tid = 0:(1/fc):(length(Mottatt_US)*(1/fc));
%Upcon=exp(j*2*pi*Fskift*tid(1:(length(tid)-1)));
%Mottatt_US_UC=Upcon.*Mottatt_US;
%clear tid;
%clear Upcon;

%Mottatt=real(Mottatt_US_UC);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Signal shift
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

if size(nodeinfo,1)>1;
for n=1:size(nodeinfo,1);
       delay=(Ts(1))*rand;
       Mottatt_Baseband_shift{n}=cp0804_signalshift(Mottatt_Baseband(n,:),(fb*10^9),delay);
end

for node=1:size(nodeinfo,1);
    node
%Genererer shiftet totalsignal fra node nr 1, til node nr:node
 Mottatt_shift_sum{1}=0;   
k=1;
    while k<node
        Mottatt_shift_sum{1}=sumarray(Mottatt_Baseband_shift{k},Mottatt_shift_sum{1});
        k
        k=k+1;
    end

%Generer shiftet sum fra node nr:#node+1 til node totalt, bortsett fra for siste
%node.
    k=node+1;
   while k<=size(nodeinfo,1);
      Mottatt_shift_sum{1}=sumarray(Mottatt_Baseband_shift{k},Mottatt_shift_sum{1}); 
    k
      k=k+1;
   end


   %summerer shiftet signal av de andre nodene med baseband signal til
   %noden som skal dekodes.
   Mottatt_Baseband_tot{node}=sumarray(Mottatt_shift_sum{1},Mottatt_Baseband(node,:));
   
end
clear Mottatt_shift_sum Mottatt_Baseband_shif;

else
    Mottatt_Baseband_tot{1}=Mottatt_Baseband(1,:);
    disp('bare 1 node')
end

clear Mottatt_Baseband;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Maske generateor
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
for n=1:size(nodeinfo,1);
numpulser=Ns(Nsnr)*length(bits(n,:));
[mask0(n,:), mask1(n,:)] = cp0801_PPMcorrmask_moda_conj(Ref_DC_DS(n,:),(fb*10^9),numpulser,dPPM);
[mask3(n,:)] = cp0801_PPMcorrmask(Referanse(n,:),fc,numpulser,dPPM);
end

clear Ref_DC_DS;


%figure
%psd=cp0301_PSD(mask3,fc);
%title('mask3')


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%[mask3_BPfilt]=bandpass(mask3,fc);
%mask3_hilb=hilbert(mask3_BPfilt);
%tid = 0:(1/fc):(length(mask3_hilb)*(1/fc)); %Genererer en tidsvektor for nedkonverteringsmatrisen.
%Downcon=exp(-j*2*pi*Fskift*tid(1:(length(tid)-1))); %Generer nedkonverteringsmatrisen
%mask3_DC=Downcon.*mask3_hilb; %Danner nedtxkonvertert signal
%clear tid;
%clear Downcon;

%mask3_DC_DS=resample(mask3_DC,fb,(fc/(1e9)));

%clear Ref_hilb Ref_DC;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%mask_US=resample(mask,(fc/(1e9)),fb);
%tid = 0:(1/fc):(length(mask_US)*(1/fc));
%Upcon=exp(j*2*pi*Fskift*tid(1:(length(tid)-1)));
%mask_US_UC=Upcon.*mask_US;
%clear tid;
%clear Upcon;

for n=1:size(nodeinfo,1)
    numpulser=Ns(Nsnr)*length(bits(n,:))
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Stoygenerering
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[output(n,:),noise_real,noise_complex,SNRdB] = stoy_AWGN_ny(Stx_DC_DS(n,:),numpulser,Pow,fb,Ts(n));
outputny(n,:)=Mottatt_Baseband_tot{n}+noise_complex;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Mottaker
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
numbit = length(bits(n,:));
[RXbits_DC_corr(n,:),BER_DC_corr(n)] = cp0801_PPMreceiver_moda(outputny(n,:),mask0(n,:),mask1(n,:),(fb*10^9),bits(n,:),numbit,Ns(Nsnr),Ts(n));
[RXbits_DC_UStoy(n,:),BER_DC_UStoy(n)] = cp0801_PPMreceiver_moda(Stx_DC_DS(n,:),mask0(n,:),mask1(n,:),(fb*10^9),bits(n,:),numbit,Ns(Nsnr),Ts(n));
clear stoy tempRxtot temp2RXtot;
end


for k=1:size(nodeinfo,1)
Ns_BER{k,Nsnr}=[BER_DC_corr(k) BER_DC_UStoy(k)]
end

clear Stxtot Referanse pulsrekke THcodes Stx_DC_DS noise_real noise_complex output noise3 output3 outputny Mottatt_Baseband_tot mask3 mask0 mask1;
end

resultat{simnr}=Ns_BER;
end
save Sim_NS2_ulikepulser_node4.mat resultat Ns numbit Pow;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%Plotter
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%figure
%plot(Mottatt)
%title('Mottatt signal ved basebandkonvolusjon')
